* Variables containing metadata from files...
*
*    LEVEL  - Data level (eg. '3AL')
*    SATID  - Satellite ID (ie. 'UARS')
*    RECTYP - Record type
*    INSTID - Intrument ID (ie. 'ISAMS')
*    PHYREC - Physical Record Number
*    SPARE  - Spare bytes in records
*    TNP    - Total Number of data Points in record
*    NP     - Number of used data Points in record
*    SI     - Starting Index of first data point
*    UDTF   - Date/Time of record in Universal Date Time Format
*    LAT    - Latitude
*    LONG   - Longitude
*    LST    - Local Solar Time
*    SZA    - Solar Zenith Angle
*
      CHARACTER LEVEL*3,SATID*4,RECTYP*2,INSTID*12,PHYREC*8,SPARE*2
      INTEGER   TNP,NP,SI,UDTF(2)
      REAL      LAT,LONG,LST,SZA
*
* Variables containing data/quality values from data files...
*
*    IDATA  - Integer representation of data value
*    RDATA  - Real representation of data value
*    IQUAL  - Integer representation of quality value
*    RQUAL  - Real representation of quality value
*
      INTEGER   IDATA,IQUAL
      REAL      RDATA,RQUAL
      EQUIVALENCE (IDATA,RDATA)
      EQUIVALENCE (IQUAL,RQUAL)
*
* Variables containing values from parameter files...
*
*    NUM32W - Number of 32-bit words in record
*    SDIREC - Sun direction
*    SUNVIE - Sun view
*    PMCPID -
*    PRCIDM -
*    LOS    -
*    LAST2  - Last two bytes needed to pad out a full 32 bit word
*
      INTEGER     NUM32W
      BYTE        SDIREC,SUNVIE,PMCPID(8)
      INTEGER*2   PRCIDM,LOS
      CHARACTER*2 LAST2
*
* Miscellaneous variables...
*
*    IREC   - Current record number for direct access files
*    BINPOS - Current postition in BINPOS
*    ASCPOS - Current postition in ASCPOS
*    RWIDTH - Width of real data/quality values in ASCII file
*    I      - Temporary value
*    VALID  - Routine to test whether RDATA/RQUAL is a valid real
*    NULL   - ASCII string to use in place of invalid reals
*
      INTEGER   IREC, BINPOS, ASCPOS, I
      INTEGER   RWIDTH
      LOGICAL   VALID
      CHARACTER NULL*17

      PARAMETER (RWIDTH = 17)
      PARAMETER (NULL = 'NaN')
