      SUBROUTINE RBMETA
      IMPLICIT NONE
*
* RBMETA - Read Binary meta-data part of a data record into common block
*
* Not all the meta data values are used in all types of level 3A file
* (for example, the starting index SI is not used in 3TP files, and LST
* and SZA are not used in either 3LP or 3TP files). However, the format
* of this part of the record is the same for all the file types and the
* unused values are simply padded out with zero values. Therefore, they
* can all be read in the same way.
*
* Local Variables...
*    BINREC - Binary record read from input file
*                     
      INCLUDE 'misc.inc'
      INCLUDE 'labl.inc'
      INCLUDE 'meta.inc'
      CHARACTER BINREC*500

      CALL RBREAD (BINREC)

      IF (BINREC(1:1) .EQ. '1') THEN
         RECKEY = BINREC(1:20)
         RECORD = BINREC(21:)
      ELSE
         RECKEY = ' '
         RECORD = BINREC
      ENDIF

      IF (RECORD(1:6) .NE. 'UARS 3') THEN
         PRINT *,'* Not a UARS data record'
         STOP

      ELSE
         READ (UNIT=RECORD(1:64),FMT=1010)
     +      SATEID,RECTYP,INSTID,PRECNO,SPARE,TNP,NP,SI,
     +      UDTF(1),UDTF(2),LAT,LONG,LST,SZA

 1010    FORMAT (A4,A2,A12,A8,A2,36A)

      ENDIF

      RETURN
      END
